<?php

    // Simple class which extends standard SimpleXML functionality

   function removeNode(SimpleXMLElement $xml, $path, $multi='one')
   { 
       $result = $xml->xpath($path);
                 
          if (!isset($result[0])) return false;
         
          switch ($multi) {
              case 'all':
                   foreach ($result as $r){
                      if (@isset($r[0])) unset($r[0]);
              }
                 return true;
                    
                case 'child':
                   unset($result[0][0]);
                   return true;
                 
                case 'one':
                      if (count($result[0]->children())==0 && count($result)==1) {
                       unset($result[0][0]);
                       return true;
                   }
                   
                default:
                      return false;             
          }
 }  

 
   function addNode(SimpleXMLElement $xml, $path, $node, $value='')
   {
       $result = $xml->xpath($path);
       
          if (!isset($result[0])) return false;
         
          foreach ($result as $r) $r->addChild($node, $value);
         
          return true;
   }  
   

   function updateNode(SimpleXMLElement $xml, $path, $value)
   {
         $result = $xml->xpath($path);
                 
         if (!isset($result[0])) return false;
         
         foreach ($result as $r){
             if (count($r->children())==0) $r[0]=$value;
         }
         
         return true;
   }
   

   function addAtrribute(SimpleXMLElement $xml, $path, $atrr, $value='')
   {
       $result = $xml->xpath($path);
                 
          if (!isset($result[0])) return false;
         
          foreach ($result as $r) $r[$atrr]=$value;
         
          return true;
   }
   

   function setId(SimpleXMLElement $xml, $path)
   {
       $result = $xml->xpath($path);
                 
          if (!isset($result[0])) return false;
          $i=1;
          foreach ($result as $r) {
                 $r['id']=$i;
              $i++;
          }
         
          return true;
   }
    
   
   function trimXml($xmlfile)
   {
       $dom = new DOMDocument();
        
          $dom->preserveWhiteSpace = false;
      
         if (!$dom->load($xmlfile)) return false;
      
         $dom->formatOutput = true;
      
         if (!$dom->save($xmlfile)) return false;
        
         return true;
   }
